﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using Combinatorics.Collections;
using static System.Console;

namespace predprs
{
    class Program
    {
        static void Main(string[] args)
        {
            double[,] matrix = new double[,]
            {
                { 0, 0, 0, 0, 0 },
                { 0.5, 0.1, 0.6, 0.3, 1.0 },
                { 1.0, 0.5, 1.1, 0.6, 1.2 },
                { 1.4, 1.2, 1.2, 1.3, 1.3 },
                { 2, 1.8, 1.4, 1.4, 1.3 },
                { 2.5, 2.5, 1.6, 1.5, 1.3 },
                { 2.8, 2.9, 1.7, 1.5, 1.3 },
                { 3, 3.5, 1.8, 1.5, 1.3 },
                { 3, 3.5, 1.8, 1.5, 1.3 },
                { 3, 3.5, 1.8, 1.5, 1.3 },
                { 3, 3.5, 1.8, 1.5, 1.3 }
            };

            for(int i = 0; i < matrix.GetLength(0); i++)
            {
                for (int j = 0; j < matrix.GetLength(1); j++) Write("{0:0.0} ", matrix[i, j]);
                WriteLine();
            }
            WriteLine("\n\n");

            int[] data = new int[11];
            for (int i = 0; i < 11; i++) data[i] = i;
            //foreach (int i in data) Write(i + " ");
            WriteLine("\n");

            int[] data2 = { 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 7, 8, 9, 10 };


            //Variations<int> variations = new Variations<int>(data, 5);
            Variations<int> variations = new Variations<int>(data2, 5);

            //Permutations<int> variations = new Permutations<int>(data, GenerateOption.WithRepetition);
            string bestStr = string.Empty;

            Stopwatch sw = new Stopwatch();
            sw.Start();

            //List<string> resus = new List<string>();

            List<Routes> bestResult = new List<Routes>();
            bestResult.Add(new Routes { Inc = 0, Route = "" });
            //Results str = new Results();
            //str.Res = 0;
            //str.BestSt = string.Empty;

            foreach (IList<int> v in variations)
            {
                if (v[0] + v[1] + v[2] + v[3] + v[4] == 10)
                {
                    double result = matrix[v[0], 0] + matrix[v[1], 1] + matrix[v[2], 2] + matrix[v[3], 3] + matrix[v[4], 4];
                    //result.CompareTo(bestResult[0].Inc);
                    if (result > bestResult[0].Inc)
                    {
                        // на всякий случай поля объекта делую нулевыми
                        //str.Res = 0;
                        //str.BestSt = string.Empty;


                        bestResult.Clear(); // отчистка листа при нахождении большего результата

                        //запись в поля объекта данных
                        //str.Res = result;
                        bestStr = string.Format("[{0} {1} {2} {3} {4}]", v[0], v[1], v[2], v[3], v[4]);
                        bestResult.Add(new Routes { Inc = result, Route = bestStr }); //добавление объекта в лист

                        //best = result;
                        //bestStr = string.Format("[{0} {1} {2} {3} {4}]", v[0], v[1], v[2], v[3], v[4]);

                    }
                    // если результаты совпали но строки отличаются (что-то тут странное происходит)
                    else if (result == bestResult[0].Inc)// && str.BestSt != string.Format("[{0} {1} {2} {3} {4}]", v[0], v[1], v[2], v[3], v[4]))
                    {
                        // на всякий случай поля объекта делую нулевыми
                        //str.Res = 0;
                        //str.BestSt = string.Empty;

                        bool check = true;
                        string temp = string.Format("[{0} {1} {2} {3} {4}]", v[0], v[1], v[2], v[3], v[4]);
                        foreach (var vr in bestResult) if (temp == vr.Route) check = false;

                        if (check)
                        {
                            bestResult.Add(new Routes { Inc = result, Route = temp });
                        }



                        //запись в поля объекта данных
                        //str.Res = result;
                        //str.BestSt = string.Format("[{0} {1} {2} {3} {4}]", v[0], v[1], v[2], v[3], v[4]);
                        //bestResult.Add(str);//добавление объекта в лист
                    }

                    //if (result == 5.4 && tr)
                    //{
                    //    resus.Add(r);
                    //    tr = false;
                    //}

                    //WriteLine("[{0} {1} {2} {3} {4}]   {5}", v[0], v[1], v[2], v[3], v[4], result);
                    //Thread.Sleep(100);
                }
            }
            //foreach (string s in resus) WriteLine(s);
            sw.Stop();
            // вывод листа 
            WriteLine(bestResult.Count);
            foreach (var route in bestResult)
            {

                WriteLine("Наибольшая прибыль при {0} со значением {1}", route.Inc, route.Route);
            }


            WriteLine("{0} ms", sw.ElapsedMilliseconds);
            ReadKey();
        }

       class Routes
        {
           public double Inc { get; set; }
           public string Route { get; set; }
        }
    }
}
